(* $Id: $ *)

{
  open UnrulyParser
  exception Error
}

rule token = parse
  (* Ignore spaces, tabs and carriage returns. *)
  | [' ' '\t' '\r']     { token lexbuf }
  (* Ignore comments. *)
  | '#' ([^'\n']*)      { token lexbuf }
  (* Update line count on new lines. *)
  | '\n'                { Lexing.new_line lexbuf ; TK_EOL }

  (* Keywords. *)
  | 'T'                 { TK_TRUE }
  | 'F'                 { TK_FALSE }
  | '_'                 { TK_UNKNOWN }

  (* End of file. *)
  | eof                 { TK_EOF }

  (* Fail if nothing else matched. *)
  | _                   { raise Error }
