(* $Id: $ *)

%{
  let pair n x = (n, x)

  let add_cell (m, t, f) =
    function
    | None -> (m+1, t, f)
    | Some true -> (m+1, (m+1) :: t, f)
    | Some false -> (m+1, t, (m+1) :: f)
%}

%token TK_TRUE
%token TK_FALSE
%token TK_UNKNOWN
%token TK_EOL
%token TK_EOF

(*
 * Returns a tuple (rows, columns, true_cells, false_cells) that is of type
 * UnrulySolver.game.
 *)
%start <UnrulySolver.game> main

%%

main:
| list(TK_EOL) grid list(TK_EOL) TK_EOF
  { let (n, m, t, f) = $2 in (n, m, List.rev t, List.rev f) }

grid:
| grid TK_EOL row
  { let (n, m, t, f) = $1
    and (m', t', f') = $3
    in
    if m = m' then
      let n' = n+1
      in
      let (t'', f'') = (List.map (pair n') t', List.map (pair n') f')
      in
      (n', m, t'' @ t, f'' @ f)
    else
      failwith "non-square grid" }
| row
  { let (m, t, f) = $1 in (1, m, List.map (pair 1) t, List.map (pair 1) f) }

row:
| row cell              { add_cell $1 $2 }
| cell                  { add_cell (0, [], []) $1 }

cell:
| TK_TRUE               { Some true }
| TK_FALSE              { Some false }
| TK_UNKNOWN            { None }
